var isAddingEntry = false;
var entryCount = 1;

function onLoad() {
    checkMaxForwardLimit();
    loadAddresses();
}

function validateInput() {
    var isValid = true;
    var newAddress = document.getElementById("new_address");
    var newRoom = document.getElementById("new_room");
    if (isAddingEntry) {
        if (!/^\d+$/.test(newRoom.value)) {
            newRoom.style.borderColor = "#CF102D";
            isValid = false;
        } else {
            newRoom.style.borderColor = "#ccc";
        }

        if (newAddress.value === "") {
            newAddress.style.borderColor = "#CF102D";
            isValid = false;
        } else {
            newAddress.style.borderColor = "#ccc";
        }
    }

    if (!isValid) {
        alert("Error saving settings - check form input");
    } else {
        saveAddresses();
        onSubmit();
    }
}

function addNewEntry(addEntryButton) {
    if (checkMaxForwardLimit()) {
        if (isAddingEntry) {
            document.getElementById("new_entry_section").style.display = "none";
            addEntryButton.value = "Add Entry";
            isAddingEntry = false;
        } else {
            document.getElementById("new_entry_section").style.display = "";
            addEntryButton.value = "Cancel";
            isAddingEntry = true;
        }
    }
}

function loadAddresses() {
    for (var i = 0; i < entryCount; i++) {
        var item = document.getElementById("forwarding_address_" + i);
        item.value = item.value.trim();
        item.value = item.value.replace(/\s/g, "");
        var pos = item.value.indexOf(';');
        if (pos >= 0) {
            var lastPos = item.value.lastIndexOf(';');
            var length = item.value.length;
            if (pos == lastPos && lastPos == length) {
                item.value = item.value.replace(';', '');
            } else {
                item.value = item.value.replace(/;/g, ';\n');
            }
        }

        updateCellHeight(item);
    }
}

function saveAddresses() {
    for (var i = 0; i < entryCount; i++) {
        var item = document.getElementById("forwarding_address_" + i);
        item.value = item.value.trim();
        item.value = item.value.replace(/\s/g, "");
        var pos = item.value.indexOf(';');
        if (pos >= 0) {
            var lastPos = item.value.lastIndexOf(';');
            var length = item.value.length;
            if (lastPos == length - 1) {
                item.value = item.value.substring(0, lastPos);
            }
        }
    }
}

function updateCellHeight(element) {
    element.style.height = (element.scrollHeight) + "px";
}

function onEditItem(index) {
    var roomCell = document.getElementById("td_room_number_" + index);
    var room = document.getElementById("room_number_" + index);
    var address = document.getElementById("forwarding_address_" + index);
    var trackEditCell = document.getElementById("track_edit_" + index);
    room.disabled = false;
    address.disabled = false;
    trackEditCell.value = 1;
}

function onDeleteItemCheckedChanged(index) {
    var deleteItem = document.getElementById("delete_" + index);
    var trackDeleteCell = document.getElementById("track_delete_" + index);
    if (deleteItem.checked) {
        trackDeleteCell.value = 1;
    } else {
        trackDeleteCell.value = 0;
    }
}
